#include <iostream>

unsigned int square(unsigned int n) {
    return n * n;
}

unsigned int subseqCnt(const std::string& tiles) {
    unsigned int subseqCnt = 0u;
    const size_t tileCnt = tiles.size();

    for (size_t s = 0u; s <= tileCnt - 9u; ++s) {
        unsigned int sideLen = 3u;
        unsigned int xCount = 0u;

        for (size_t e = s; e < tileCnt; ++e) {
            if (tiles.at(e) == 'X')
                ++xCount;
            if (e - s + 1u != square(sideLen))
                continue;
            if (xCount == 4 * (sideLen - 1) || xCount == square(sideLen - 2))
                ++subseqCnt;

            ++sideLen;
        }
    }

    return subseqCnt;
}

int main() {
    size_t tileCnt;
    std::string tiles;

    std::cin >> tileCnt >> tiles;
    std::cout << subseqCnt(tiles) << std::endl;

    return 0;
}
